class FeatureManagement:
    def NewFeature(self, vector):

	for vec in vector:
		
		newlist = []

		
		newvector = [vec[i] for i in range(229, 229+400)]
		#count number of a 5'
		tempvector = newvector[:48]
		sone1 = [sone1a5 , sone1c5 , sone1g5 , sone1u5] = FeatureManagement().GetComposition(tempvector)
                
		#count number of c 5'
		tempvector = newvector[:96]
                sone2 = [sone2a5 , sone2c5 , sone2g5 , sone2u5] = FeatureManagement().GetComposition(tempvector[48:])

		#count number of g 5'
		tempvector = newvector[:144]
                sone3 = [sone3a5 , sone3c5 , sone3g5 , sone3u5] = FeatureManagement().GetComposition(tempvector[96:])	

		#count number og u 5'
		tempvector = newvector[:192]
                sone4 = [sone4a5 , sone4c5 , sone4g5 , sone4u5] = FeatureManagement().GetComposition(tempvector[144:])

		#count number of a 3'
		tempvector = newvector[:248]
                sone5 = [sone5a5 , sone5c5 , sone5g5 , sone5u5] = FeatureManagement().GetComposition(tempvector[200:])

		#count number of c 3'
		tempvector = newvector[:296]
                sone6 = [sone6a5 , sone6c5 , sone6g5 , sone6u5] = FeatureManagement().GetComposition(tempvector[248:])

		#count number of g 3'
		tempvector = newvector[:344]
                sone7 = [sone7a5 , sone7c5 , sone7g5 , sone7u5] = FeatureManagement().GetComposition(tempvector[296:])

		#count number of u 3'
		tempvector = newvector[:392]
                sone8 = [sone8a5, sone8c5, sone8g5, sone8u5] = FeatureManagement().GetComposition(tempvector[344:])
		
		temp = [sone1, sone2, sone3, sone4, sone5, sone6, sone7, sone8]
                
		newFeature = []
		for i in range(4):
			for item in temp:
				newFeature.append(item[i])
	
		for element in newFeature:
			vec.append(element)

	return vector

    def GetComposition(self, vector):

        a = [1,0,0,0]
        c = [0,1,0,0]
        g = [0,0,1,0]
        u = [0,0,0,1]
        acount = ccount = gcount = ucount = 0
        
        for i in range(12):
            temp =i*4
            templist = vector[temp:temp+4]
            if templist == a:
                acount = acount + 1
            if templist == c:
                ccount = ccount + 1
            if templist == g:
                gcount = gcount + 1
            if templist == u:
                ucount = ucount + 1
                
	return [float(acount)/12, float(ccount)/12, float(gcount)/12, float(ucount)/12]

    def FeatureScaling(self, pos, neg, values):
	if not values:
            temp1 = temp2 = temp3 = -999
            temp4 = 999
            temp5 = -999
      

            for temp in pos:
                if temp1 < temp[1]:
                    temp1 = temp[1]
                if temp2 < temp[2]:
                    temp2 = temp[2]
                if temp3 < temp[677]:
                    temp3 = temp[677]
                if temp4 > temp[3]:
                    temp4 = temp[3]
                if temp5 < temp[228]:
                    temp5 = temp[228]
				
            for temp in neg:
                if temp1 < temp[1]:
                    temp1 = temp[1]
                if temp2 < temp[2]:
                    temp2 = temp[2]
                if temp3 < temp[677]:
                    temp3 = temp[677]
                if temp4 > temp[3]:
                    temp4 = temp[3]
                if temp5 < temp[228]:
                    temp5 = temp[228]
            values = [temp1, temp2, temp3, temp4, temp5]
	else:
            [temp1, temp2, temp3, temp4, temp5] = values
	
	for k in range(len(pos)):
            pos[k][1] =  float(pos[k][1])/temp1
            pos[k][2] =  float(pos[k][2])/temp2
            pos[k][3] =  float(pos[k][3])/-temp4
            pos[k][677] =float(pos[k][677])/temp3
            
            pos[k][228] =float(pos[k][228])/temp5
            for i in range(220, 228):
                pos[k][i] = float(pos[k][i])/24
            
        for k in range(len(neg)):
            neg[k][1] =  float(neg[k][1])/temp1
            neg[k][2] =  float(neg[k][2])/temp2
            neg[k][3] =  float(neg[k][3])/-temp4
            neg[k][677] =float(neg[k][677])/temp3
            
            neg[k][228] =float(neg[k][228])/temp5
            for i in range(220, 228):
                neg[k][i] = float(neg[k][i])/24
            
	return [pos, neg, values]

    #change this so that it scales down the new features
    def SecondFeatureScaling(self,vector, values):
        print len(vector)
        temp1 = temp2 = temp3 = -999
        temp4 = temp5 = temp6 = -999
        temp7 = temp8 = temp9 = -999
      

        for temp in vector:
            if temp1 < abs(temp[678]):
                temp1 = abs(temp[678])
            if temp2 < abs(temp[679]):
                temp2 = abs(temp[679])
            if temp3 < abs(temp[680]):
                temp3 = abs(temp[680])
            if temp4 < abs(temp[681]):
                temp4 = abs(temp[681])
            if temp5 < abs(temp[682]):
                temp5 = abs(temp[682])
            if temp6 < abs(temp[683]):
                temp6 = abs(temp[683])
            if temp7 < abs(temp[684]):
                temp7 = abs(temp[684])
            if temp8 < abs(temp[685]):
                temp8 = abs(temp[685])
            if temp9 < abs(temp[686]):
                temp9 = abs(temp[686])
                    
	
           
        values = [temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, temp9]
	
	for k in range(len(vector)):
            vector[k][678] =  float(vector[k][678])/temp1
            vector[k][679] =  float(vector[k][679])/temp2
            vector[k][680] =  float(vector[k][680])/temp3
            vector[k][681] =  float(vector[k][681])/temp4
            vector[k][682] =  float(vector[k][682])/temp5
            vector[k][683] =  float(vector[k][683])/temp6
            vector[k][684] =  float(vector[k][684])/temp7
            vector[k][685] =  float(vector[k][685])/temp8
            vector[k][686] =  float(vector[k][686])/temp9

	return vector
        
    
    def RemoveFeature(self, vector, startkey, numfeatures):
        for k in range(len(vector)):
            for i in range(startkey, startkey+numfeatures):
                del vector[k][i]
		
        return vector
